#!/usr/bin/ruby

require 'socket'
require 'json'
require 'date'

$host = Socket.gethostname
$time = Time.now.to_i

$output = []

stat=`w -h -s -i`

stat.each_line do |line|
   line = line.chomp.gsub(/ [ ]*/, ' ')
   items = line.split(/ /)
   next if items[0] == 'root'
   ctime = 0
   mtime = 0
   begin
       stat = File.stat("/dev/#{items[1]}")
       ctime = stat.ctime.to_i
       mtime = stat.mtime.to_i
   rescue
   end
   $output << { 'name' => 'whos', 'host' => $host, 'host_t' => $host, 'time' => $time, 'user' => items[0], 'remoteip' => items[2], 'cmd' => items[4..-1].join(' '), 'login' => ctime, 'idle' => mtime }
end

puts JSON.pretty_generate($output)
